=== debian/changelog ===
yubihsm-shell (2.7.0-3) unstable; urgency=medium

  * Don't build shared libraries with -pie (closes: #1113655).

 -- Colin Watson <cjwatson@debian.org>  Fri, 26 Sep 2025 13:58:24 +0100

yubihsm-shell (2.7.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Colin Watson <cjwatson@debian.org>  Sun, 10 Aug 2025 10:38:27 +0100

yubihsm-shell (2.7.0-1) experimental; urgency=medium

  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Mon, 16 Jun 2025 11:39:07 +0100
