=== debian/control ===
Source: yubihsm-shell
Section: utils
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders:
 Freexian Packaging Team <team+freexian@tracker.debian.org>,
 Colin Watson <cjwatson@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.29),
 gengetopt,
 help2man,
 libcurl4-openssl-dev,
 libedit-dev,
 libpcsclite-dev,
 libssl-dev,
 libusb-1.0-0-dev,
 pkgconf,
 zlib1g-dev,
Standards-Version: 4.7.0
Homepage: https://developers.yubico.com/yubihsm-shell/
Vcs-Browser: https://salsa.debian.org/pkg-security-team/yubihsm-shell
Vcs-Git: https://salsa.debian.org/pkg-security-team/yubihsm-shell.git
X-Style: black

Package: libyubihsm2
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 libyubihsm-http2 (= ${binary:Version}) | libyubihsm-usb2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
# Upstream's library package names don't match the SONAME.
Breaks:
 libyubihsm1,
Replaces:
 libyubihsm1,
Description: YubiHSM 2 communication library
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains the main run-time shared library.

Package: libyubihsm-usb2
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 libyubihsm2,
# Upstream's library package names don't match the SONAME.
Breaks:
 libyubihsm-usb1,
Replaces:
 libyubihsm-usb1,
Description: YubiHSM 2 communication library (direct USB access)
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains backend functions used by libyubihsm2 to access the
 device directly over USB.

Package: libyubihsm-http2
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 libyubihsm2,
Suggests:
 yubihsm-connector,
# Upstream's library package names don't match the SONAME.
Breaks:
 libyubihsm-http1,
Replaces:
 libyubihsm-http1,
Description: YubiHSM 2 communication library (HTTP access)
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains backend functions used by libyubihsm2 to access the
 device over HTTP via yubihsm-connector.

Package: libyubihsm-dev
Section: libdevel
Architecture: any
Depends:
 libyubihsm2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: YubiHSM 2 communication library (development files)
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains the development files for the library.

Package: libykhsmauth2
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
# Upstream's library package names don't match the SONAME.
Breaks:
 libykhsmauth1,
Replaces:
 libykhsmauth1,
Description: YubiKey HSM authentication library
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains a run-time shared library for interacting with the
 HSM authentication application on a YubiKey, which can be used to access
 the YubiHSM 2.

Package: libykhsmauth-dev
Section: libdevel
Architecture: any
Depends:
 libykhsmauth2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: YubiKey HSM authentication library (development files)
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains development files for the library to interact with
 the HSM authentication application on a YubiKey, which can be used to
 access the YubiHSM 2.

Package: yubihsm-pkcs11
Section: libs
Architecture: any
Depends:
 libyubihsm2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: PKCS#11 module for communication with the YubiHSM 2
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains a PKCS#11 module, allowing software that supports
 that interface standard to use a YubiHSM 2 device.

Package: yubihsm-shell
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: command-line and interactive tool for the YubiHSM 2
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains the yubihsm-shell command-line tool for interacting
 with the YubiHSM 2.

Package: yubihsm-wrap
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: produce offline wrapped objects for the YubiHSM 2
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 YubiHSM 2 devices support exporting and importing objects under a Wrap Key,
 allowing them to be transferred between devices while preserving
 confidentiality.  This package contains the yubihsm-wrap command-line tool
 to allow creating wrapped objects from a computer.

Package: yubihsm-auth
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: store YubiHSM 2 authentication keys on a YubiKey
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains the yubihsm-auth command-line tool to store
 authentication keys for a YubiHSM 2 on a YubiKey.
