=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dpkg/default.mk

export DEB_CPPFLAGS_MAINT_APPEND := -I/usr/include/PCSC

# We build without RPATH, so we need to set LD_LIBRARY_PATH in order that
# built programs can be run from the build tree.
builddir := $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)
LD_LIBRARY_PATH := $(builddir)/lib:$(builddir)/ykhsmauth

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
		-DCMAKE_SKIP_RPATH=ON \
		-DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \
		-DRELEASE_BUILD=1 \
		-DYUBIHSM_INSTALL_PKGCONFIG_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig

override_dh_auto_build:
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH) dh_auto_build

override_dh_auto_test:
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH) dh_auto_test -- \
		ARGS+=--exclude-from-file ARGS+=$(CURDIR)/debian/ctest-exclude
